using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace vdca
{
	/// <summary>
	/// Summary description for addbatting.
	/// </summary>
	public class addbatting : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnAdd;
		protected System.Web.UI.WebControls.DropDownList ddlTeam;
		protected System.Web.UI.WebControls.DropDownList ddlATeam;
		protected System.Web.UI.WebControls.DataGrid dgBatting;
		protected System.Web.UI.WebControls.TextBox txtRuns;
		protected System.Web.UI.WebControls.TextBox txtBalls;
		protected System.Web.UI.WebControls.Button btnAddBatting;
		protected System.Web.UI.WebControls.TextBox txtDismissal;
		protected System.Web.UI.WebControls.Label lblMsg;
		protected System.Web.UI.WebControls.DropDownList ddlPlayers;

		private void CreateTable()
		{
			DataTable dt = new DataTable();
			DataColumn dc1 = new DataColumn("pid", Type.GetType("System.String") );
			DataColumn dc2 = new DataColumn("pname", Type.GetType("System.String"));
			DataColumn dc3 = new DataColumn("runs", Type.GetType("System.Int16"));
			DataColumn dc4 = new DataColumn("balls", Type.GetType("System.Int16"));
			DataColumn dc5 = new DataColumn("dismissal", Type.GetType("System.String"));

			dt.Columns.Add(dc1);
			dt.Columns.Add(dc2);
			dt.Columns.Add(dc3);
			dt.Columns.Add(dc4);
			dt.Columns.Add(dc5);
			Session.Add("batting", dt);
		}
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if ( Page.IsPostBack) return;

			CreateTable();

			SqlConnection con = new SqlConnection( (String) Application["constr"]);
			try
			{
				SqlDataAdapter cmd = new SqlDataAdapter(" select  tid, tname from teams order by tname",con);
				DataSet ds  = new DataSet();
				cmd.Fill(ds,"teams");
				 
				// data binding
				ddlTeam.DataSource = ds.Tables[0];
				ddlTeam.DataTextField= "tname";
				ddlTeam.DataValueField= "tid";
				ddlTeam.DataBind();

			}
			catch(Exception ex)
			{
				Response.Write("Error " + ex.Message);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ddlTeam.SelectedIndexChanged += new System.EventHandler(this.ddlTeam_SelectedIndexChanged);
			this.ddlATeam.SelectedIndexChanged += new System.EventHandler(this.ddlATeam_SelectedIndexChanged);
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			this.dgBatting.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.dgBatting_DeleteCommand);
			this.dgBatting.SelectedIndexChanged += new System.EventHandler(this.dgBatting_SelectedIndexChanged);
			this.btnAddBatting.Click += new System.EventHandler(this.btnAddBatting_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ddlTeam_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		  // get details of teams 

			SqlConnection con = new SqlConnection( (String) Application["constr"]);
			SqlDataAdapter cmd = new SqlDataAdapter(" select tm.mid, tname = tname + '-' +  convert(varchar(10),mdate,103) from teams t, teammatches tm , matches m where t.tid = tm.tid and m.mid = tm.mid and tm.tid <> @tid and tm.mid in ( select mid from  teammatches where  tid = @tid)",con);
			cmd.SelectCommand.Parameters.Add("@tid", SqlDbType.Int).Value = ddlTeam.SelectedItem.Value;

			DataSet ds  = new DataSet();
			cmd.Fill(ds,"teams");
			 
			// data binding
			ddlATeam.DataSource = ds.Tables[0];
			ddlATeam.DataTextField= "tname";
			ddlATeam.DataValueField= "mid";
			ddlATeam.DataBind();

			cmd = new SqlDataAdapter(" select pname,pid from players where tid  = @tid",con);
			cmd.SelectCommand.Parameters.Add("@tid", SqlDbType.Int).Value = ddlTeam.SelectedItem.Value;
			cmd.Fill(ds,"players");
			 
			// data binding
			ddlPlayers.DataSource = ds.Tables["players"];
			ddlPlayers.DataTextField= "pname";
			ddlPlayers.DataValueField= "pid";
			ddlPlayers.DataBind();
		}

		private void ddlATeam_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			// add a record to Table in dataset
			DataTable  dt = (DataTable) Session["batting"];
 
			DataRow dr = dt.NewRow();
			dr[0] = ddlPlayers.SelectedItem.Value;
			dr[1] = ddlPlayers.SelectedItem.Text;
			dr[2] = txtRuns.Text;
			dr[3] = txtBalls.Text;
			dr[4] = txtDismissal.Text;
			dt.Rows.Add(dr);
			Session.Add("batting",dt);
			dgBatting.DataSource = dt;
			dgBatting.DataBind();
			if (  dt.Rows.Count >= 2 )
				  btnAddBatting.Visible = true;
		}

		private void dgBatting_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void dgBatting_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int pos = e.Item.ItemIndex;
			// delete corresponding row 
			// add a record to Table in dataset
			DataTable  dt = (DataTable) Session["batting"];
 			dt.Rows.RemoveAt(pos);
			Session.Add("batting",dt);
			dgBatting.DataSource = dt;
			dgBatting.DataBind();
			if ( dt.Rows.Count <2 )
				 btnAddBatting.Visible= false;

		}

		private void btnAddBatting_Click(object sender, System.EventArgs e)
		{
			// add details to BATTINGS table
			SqlConnection con = new SqlConnection( (String) Application["constr"]);
			SqlTransaction trans=null;
			
			try
			{
				con.Open();
				trans = con.BeginTransaction ();	
				SqlCommand cmd = new SqlCommand("insert into batting values(@mid, @pid,@pos,@runs,@balls,@dismissal)",con);
				cmd.Transaction = trans;
				cmd.Parameters.Add("@mid",SqlDbType.Int);
				cmd.Parameters.Add("@pid",SqlDbType.Int);
				cmd.Parameters.Add("@pos",SqlDbType.Int);
				cmd.Parameters.Add("@runs",SqlDbType.Int);
				cmd.Parameters.Add("@balls",SqlDbType.Int);
				cmd.Parameters.Add("@dismissal",SqlDbType.VarChar,30);

				DataTable  dt = (DataTable) Session["batting"];
				int pos  = 1;
				foreach(DataRow dr in dt.Rows)
				{
					cmd.Parameters[0].Value = ddlATeam.SelectedItem.Value;
					cmd.Parameters[1].Value = dr[0];
					cmd.Parameters[2].Value = pos;
					cmd.Parameters[3].Value = dr[2];
					cmd.Parameters[4].Value = dr[3];
					cmd.Parameters[5].Value = dr[4];
					cmd.ExecuteNonQuery ();
					pos++;
				}
				trans.Commit();
				// remove session variable's data
				dt.Rows.Clear();
				dgBatting.DataSource = dt;
				dgBatting.DataBind();
				Session.Add("batting",dt);
				lblMsg.Text = "Batting Details Added!!!";

			}
			catch(Exception ex)
			{
				trans.Rollback();
				Response.Write(ex.Message );
			}
			finally
			{
				con.Close();
			}


			

			

		}

		
	}
}
