using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace vdca
{
	/// <summary>
	/// Summary description for addbowling.
	/// </summary>
	public class addbowling : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList Ddlteam;
		protected System.Web.UI.WebControls.DropDownList Ddlplayer;
		protected System.Web.UI.WebControls.TextBox Txtwickets;
		protected System.Web.UI.WebControls.TextBox Txtruns;
		protected System.Web.UI.WebControls.TextBox Txtmovers;
		protected System.Web.UI.WebControls.Button Addbtn;
		protected System.Web.UI.WebControls.DataGrid Dgbowling;
		protected System.Web.UI.WebControls.Button AddBowlingDetails;
		protected System.Web.UI.WebControls.TextBox Txtovers;
		protected System.Web.UI.WebControls.Label lblMsg;
		protected System.Web.UI.WebControls.DropDownList Ddlmatch;
		
		private void CreateTable()
		{
			DataTable dt=new DataTable();
			DataColumn dc1=new DataColumn("pid",Type.GetType("System.Int16"));
			DataColumn dc2=new DataColumn("pname",Type.GetType("System.String"));
			DataColumn dc3=new DataColumn("wickets",Type.GetType("System.Int16"));
			DataColumn dc4=new DataColumn("runs",Type.GetType("System.Int16"));
			DataColumn dc5=new DataColumn("overs",Type.GetType("System.Int16"));
			DataColumn dc6=new DataColumn("movers",Type.GetType("System.Int16"));
			dt.Columns.Add(dc1);
			dt.Columns.Add(dc2);
			dt.Columns.Add(dc3);
			dt.Columns.Add(dc4);
			dt.Columns.Add(dc5);
			dt.Columns.Add(dc6);
			Session.Add("bowling",dt);
		}
		private void Page_Load(object sender, System.EventArgs e)
		{
			
			if(Page.IsPostBack)return;
			CreateTable();
			SqlConnection con=new SqlConnection((string)Application["constr"]);
			try
			{
				SqlDataAdapter cmd=new SqlDataAdapter("select tid,tname from teams order by tname",con);
				DataSet ds=new DataSet();
				cmd.Fill(ds,"teams");
				Ddlteam.DataSource=ds.Tables[0];
				Ddlteam.DataTextField="tname";
				Ddlteam.DataValueField="tid";
				Ddlteam.DataBind();
			}
			catch(Exception ex)
			{
				lblMsg.Text="Errot:" + ex.Message;
			}
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Ddlteam.SelectedIndexChanged += new System.EventHandler(this.Ddlteam_SelectedIndexChanged);
			this.Addbtn.Click += new System.EventHandler(this.Addbtn_Click);
			this.Dgbowling.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.Dgbowling_DeleteCommand);
			this.AddBowlingDetails.Click += new System.EventHandler(this.AddBowlingDetails_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Ddlteam_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			SqlConnection con=new SqlConnection((string)Application["constr"]);
			SqlDataAdapter cmd=new SqlDataAdapter("select tm.mid,tname=tname+'-'+convert(varchar(10),mdate,103)from teams t,teammatches tm,matches m where t.tid=tm.tid and m.mid=tm.mid and tm.tid <>@tid and tm.mid in(select mid from teammatches where tid=@tid)",con);
			cmd.SelectCommand.Parameters.Add("@tid",SqlDbType.Int).Value=Ddlteam.SelectedItem.Value;
			DataSet ds=new DataSet();
			cmd.Fill(ds,"teams");
			//Data Binding
			Ddlmatch.DataSource=ds.Tables[0];
			Ddlmatch.DataTextField="tname";
			Ddlmatch.DataValueField="mid";
			Ddlmatch.DataBind();
			cmd=new SqlDataAdapter("select pname,pid from players where tid=@tid",con);
			cmd.SelectCommand.Parameters.Add("@tid",SqlDbType.Int).Value=Ddlteam.SelectedItem.Value;
			cmd.Fill(ds,"players");
			//Data Binding
			Ddlplayer.DataSource=ds.Tables["players"];
			Ddlplayer.DataTextField="pname";
			Ddlplayer.DataValueField="pid";
			Ddlplayer.DataBind();
		}

		private void Addbtn_Click(object sender, System.EventArgs e)
		{
			DataTable dt=(DataTable)Session["bowling"];
			DataRow dr=dt.NewRow();
			dr[0]=Ddlplayer.SelectedItem.Value;
			dr[1]=Ddlplayer.SelectedItem.Text;
			dr[2]=Txtwickets.Text;
			dr[3]=Txtruns.Text;
			dr[4]=Txtovers.Text;
            dr[5]=Txtmovers.Text;

			dt.Rows.Add(dr);
			Session.Add("bowling",dt);
			Dgbowling.DataSource=dt;
			Dgbowling.DataBind();
			if(dt.Rows.Count>=2)
				AddBowlingDetails.Visible=true;
		}

		private void AddBowlingDetails_Click(object sender, System.EventArgs e)
		{
			SqlConnection con=new SqlConnection((string)Application["constr"]);
			SqlTransaction trans=null;
			try
			{
				con.Open();
				trans=con.BeginTransaction();
				SqlCommand cmd=new SqlCommand("insert into bowling values(@mid,@pid,@pos,@wickets,@runs,@overs,@movers)",con);
				cmd.Transaction=trans;
				cmd.Parameters.Add("@mid",SqlDbType.Int);
				cmd.Parameters.Add("@pid",SqlDbType.Int);
				cmd.Parameters.Add("@pos",SqlDbType.Int);
				cmd.Parameters.Add("@wickets",SqlDbType.Int);
				cmd.Parameters.Add("@runs",SqlDbType.Int);
				cmd.Parameters.Add("@overs",SqlDbType.Int);
				cmd.Parameters.Add("@movers",SqlDbType.Int);
				
				DataTable dt=(DataTable)Session["bowling"];
				int pos=1;
				foreach(DataRow dr in dt.Rows)
				{
					cmd.Parameters[0].Value=Ddlmatch.SelectedItem.Value;
					cmd.Parameters[1].Value=dr[0];
					cmd.Parameters[2].Value=pos;
					cmd.Parameters[3].Value=dr[2];
					cmd.Parameters[4].Value=dr[3];
					cmd.Parameters[5].Value=dr[4];
					cmd.Parameters[6].Value=dr[5];
					cmd.ExecuteNonQuery();
					pos++;
				}
				trans.Commit();
				dt.Rows.Clear();
				Dgbowling.DataSource=dt;
				Dgbowling.DataBind();
				Session.Add("bowling",dt);
				lblMsg.Text="Bowlong Details Added !!!";
			}
			catch(Exception ex)
			{
				trans.Rollback();
				Response.Write(ex.Message);
			}
			finally
			{
				con.Close();
			}
		}

		private void Dgbowling_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int pos=e.Item.ItemIndex;
			Response.Write(pos);
			DataTable dt=(DataTable)Session["bowling"];
			dt.Rows.RemoveAt(pos);
			Session.Add("bowling",dt);
			Dgbowling.DataSource=dt;
			Dgbowling.DataBind();
			if(dt.Rows.Count<2)
				AddBowlingDetails.Visible=false;
		}
	}
}
